#include <stdlib.h>
#include <stdio.h>

int GetUTMZone_old( double dfCentralMeridian )
{
    double dfZone = ( dfCentralMeridian + 183 ) / 6.0 + 0.000000001;

    if( abs(dfZone - (int) dfZone) > 0.00001
        || dfCentralMeridian < -177.00001
        || dfCentralMeridian > 177.000001 )
        return 0;
    else
        return (int) dfZone;
}

int GetUTMZone_new( double dfCentralMeridian )
{
    double dfZone = ( dfCentralMeridian + 186.0 ) / 6.0;

    if( abs(dfZone - (int) dfZone - 0.5 ) > 0.00001
        || dfCentralMeridian < -177.00001
        || dfCentralMeridian > 177.000001 )
        return 0;
    else
        return (int) dfZone;
}

int main(int argc, char** argv)
{
    int nTotal = 0;
    int nCount = 0;
    int i = 0;
    for(i = -180; i < 180; i++)
    {
        double dfVal = (double) i;
        int nOld = GetUTMZone_old(dfVal);
        int nNew = GetUTMZone_new(dfVal);
        printf("ctm,old,new,diff = %d,%d,%d,%d\n", i, nOld, nNew, (nNew-nOld));
        if (nOld != nNew)
            nCount++;
        nTotal++;
    }
    printf("count/total = %d,%d\n", nCount, nTotal);
    return 0;
}

